-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_endpoint"

-- **************************************************
-- General information about this script
-- **************************************************

DS_endpoint = {}
function DS_endpoint:Name()
	return "DS endpoint"
end

function DS_endpoint:Version()
	return "1.0"
end

function DS_endpoint:Description()
	return "Find endpoint"
end

function DS_endpoint:Creator()
	return "dauid.com"
end

function DS_endpoint:UILabel()
	return("Find endpoints")
end
-- **************************************************
-- Recurring values
-- **************************************************
DS_endpoint.points = {}

-- **************************************************
-- The guts of this script
-- **************************************************

function DS_endpoint:Run(moho)
local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end
	
mesh:SelectNone()
		for i = 0, mesh:CountPoints() - 1 do
			if (mesh:Point(i):IsEndpoint()) then
				mesh:Point(i).fSelected = true
			else
				mesh:Point(i).fSelected = false
			end
		end

end