-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_WalkCycleMover"

-- **************************************************
-- General information about this script
-- **************************************************

DS_WalkCycleMover = {}
function DS_WalkCycleMover:Name()
	return "DS Walkcycle mover"
end

function DS_WalkCycleMover:Version()
	return "1.0"
end

function DS_WalkCycleMover:Description()
	return "Move walkcycle"
end

function DS_WalkCycleMover:Creator()
	return "dauid.com"
end

function DS_WalkCycleMover:UILabel()
	return("DS Walkcycle mover")
end
-- **************************************************
-- Recurring values
-- **************************************************


-- **************************************************
-- The guts of this script
-- **************************************************


function DS_WalkCycleMover:Run(moho)
local endFrame = moho.document:EndFrame()
local theBone = -1
local Interpolation = 0
local AbsoluteCycle = 0
local RelativeCycle = 0
local duration = 0
local layer = moho.layer
local CycleToThis = 0
local v1 = LM.Vector2:new_local()
local v2 = LM.Vector2:new_local()
local v3 = LM.Vector2:new_local()
local v4 = LM.Vector2:new_local()
local v5 = LM.Vector2:new_local()

	if (moho.layer:LayerType() ~= MOHO.LT_BONE) then
			return false
	end
	
		
		if (skel == nil) then
				return false
		end

		local skel = moho:Skeleton()
		
		for i = 0, skel:CountBones() - 1 do --For every bone do this
			theBone=skel:Bone(i)
			if (theBone.fSelected) then 
			end
		end
	
	local ch = theBone.fAnimPos
	duration = ch:Duration()
	
	if (ch:GetKeyInterpMode(duration)== 5) then
	local lastFrame = duration + layer:TotalTimingOffset()
		Interpolation, RelativeCycle, AbsoluteCycle = ch:GetKeyInterp(duration, Interpolation,RelativeCycle, AbsoluteCycle);
		
		-------------------------------- Calculate what frame we want to cycle to
		if (AbsoluteCycle == (-1)) then --If the cycle is not set to an absolute keyframe
			CycleToThis = duration - RelativeCycle
		else
			CycleToThis = AbsoluteCycle + layer:TotalTimingOffset()
		end
		print("Cycletothis: " .. CycleToThis)
		local FrameAmount = duration - CycleToThis
		print("FrameAmount: " .. FrameAmount)
		print("----------------------------")
		for f = lastFrame+1, endFrame do
		local loopCount = math.ceil((f-CycleToThis)/FrameAmount)
		print("Loopcount: " .. loopCount)
		local subtractAmount = FrameAmount * (loopCount-1)
		print("subtractAmount:" .. subtractAmount) 
		v1 = ch:GetValue(f-subtractAmount) -- Get position from the loop
		v2 = ch:GetValue(duration) -- Get position from the end of the loop
		v3 = ch:GetValue(CycleToThis)
		v4 = (v2 - v3) * (loopCount-1)
		v5 = v1 + v4
		ch:SetValue(f, v5)
		end
	
	else
		print("Last keyframe is not a cycle")
	end
end