-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_ChannelTest"

-- **************************************************
-- General information about this script
-- **************************************************

DS_ChannelTest = {}

function DS_ChannelTest:Name()
	return "Channel test"
end

function DS_ChannelTest:Version()
	return "0.1"
end

function DS_ChannelTest:Description()
	return "Channel test"
end

function DS_ChannelTest:Creator()
	return "dauid.com"
end

function DS_ChannelTest:UILabel()
	return"Channel test"
end

-- **************************************************
-- The guts of this script
-- **************************************************

function DS_ChannelTest:Run(moho)
	local numCh = moho.layer:CountChannels()
	print(MOHO.Localize("/Scripts/Menu/ListChannels/NumberOfChannels=Number of animation channels in current layer: ") .. numCh)
	
	

	for i = 0, 5 do
		local chInfo = MOHO.MohoLayerChannel:new_local()
		moho.layer:GetChannelInfo(i, chInfo)
		if (chInfo.subChannelCount == 1) then
			local ch = moho.layer:Channel(i, 0, moho.document)
		
			--print(ch:ChannelType())
			print(MOHO.Localize("/Scripts/Menu/ListChannels/Channel=Channel ") .. i .. ": " .. chInfo.name:Buffer() .. MOHO.Localize("/Scripts/Menu/ListChannels/Keyframes= Keyframes: ") .. ch:CountKeys())
			
		else
			--print(MOHO.Localize("/Scripts/Menu/ListChannels/Channel=Channel ") .. i .. ": " .. chInfo.name:Buffer())
			for subID = 0, chInfo.subChannelCount - 1 do
				local ch = moho.layer:Channel(i, subID, moho.document)
				if ch:HasKey(2) then
				--print("Has key! "..subID)
				--print(MOHO.Localize("/Scripts/Menu/ListChannels/SubChannel=    Sub-channel ") .. subID .. MOHO.Localize("/Scripts/Menu/ListChannels/Keyframes= Keyframes: ") .. ch:CountKeys())
			end
				--print(MOHO.Localize("/Scripts/Menu/ListChannels/SubChannel=    Sub-channel ") .. subID .. MOHO.Localize("/Scripts/Menu/ListChannels/Keyframes= Keyframes: ") .. ch:CountKeys())
			end
		end
	end

end
